import CodeGen from '@alilc/lowcode-code-generator';
import vue3 from './plugins/project/vue3';
import vue from './plugins/component/vue3/vue';
import methods from './plugins/component/vue3/methods';
import lifeCycles from './plugins/component/vue3/lifeCycles';
import styles from './plugins/component/vue3/styles';
import initState from './plugins/component/vue3/initState';
import * as constants from './plugins/component/vue3/const';
import * as globalUtils from './utils';
import { prettier } from './postprocessor';
export default function createVueProjectBuilder() {
  return CodeGen.createProjectBuilder({
    template: vue3.template,
    plugins: {
      components: [
        // CodeGen.plugins.icejs.reactCommonDeps(),
        // CodeGen.plugins.common.esModule({ fileType: 'jsx' }),
        // CodeGen.plugins.common.styleImport(),
        // CodeGen.plugins.icejs.containerClass(),
        // CodeGen.plugins.icejs.containerInjectContext(),
        // CodeGen.plugins.icejs.containerInjectUtils(),
        // CodeGen.plugins.icejs.containerInjectDataSourceEngine(),
        // CodeGen.plugins.icejs.containerInjectI18n(),
        // CodeGen.plugins.icejs.containerInjectConstants(),
        // CodeGen.plugins.icejs.containerInitState(),
        // CodeGen.plugins.icejs.containerLifeCycle(),
        // CodeGen.plugins.icejs.containerMethod(),
        // examplePlugin(),
        // CodeGen.plugins.icejs.jsx({
        //   nodeTypeMapping: {
        //     Div: 'div',
        //     Component: 'div',
        //     Page: 'div',
        //     Block: 'div',
        //   },
        // }),
        // CodeGen.plugins.style.css(),
      ],
      pages: [
      // CodeGen.plugins.icejs.reactCommonDeps(),
      // CodeGen.plugins.common.esModule({ fileType: 'jsx' })
      // CodeGen.plugins.common.styleImport(),
      // CodeGen.plugins.icejs.containerClass(),
      // CodeGen.plugins.icejs.containerInjectContext(),
      // CodeGen.plugins.icejs.containerInjectUtils(),
      // CodeGen.plugins.icejs.containerInjectDataSourceEngine(),
      // CodeGen.plugins.icejs.containerInjectI18n(),
      // CodeGen.plugins.icejs.containerInjectConstants(),
      // CodeGen.plugins.icejs.containerInitState(),
      // CodeGen.plugins.icejs.containerLifeCycle(),
      // CodeGen.plugins.icejs.containerMethod(),
      // examplePlugin(),
      initState(), lifeCycles(), methods(), styles(), vue({
        nodeTypeMapping: {
          Div: 'div',
          Component: 'div',
          Page: 'div',
          Block: 'div'
        }
      })
      // CodeGen.plugins.style.css(),
      ],

      router: [
      // CodeGen.plugins.common.esModule(),
      vue3.plugins.router()],
      entry: [vue3.plugins.entry()],
      app: [vue3.plugins.app()],
      mainCss: [vue3.plugins.mainCss()],
      // constants: [CodeGen.plugins.project.constants()],
      // utils: [
      //   CodeGen.plugins.common.esModule(),
      //   CodeGen.plugins.project.utils('react'),
      // ],
      // i18n: [CodeGen.plugins.project.i18n()],
      // globalStyle: [CodeGen.solutionParts.icejs.plugins.globalStyle()],
      htmlEntry: [vue3.plugins.entryHtml()],
      packageJSON: [vue3.plugins.packageJSON()]
    },
    postProcessors: [prettier()]
  });
}
export var publishers = CodeGen.publishers;
export var plugins = {
  methods: methods,
  vue: vue,
  styles: styles,
  constants: constants,
  globalUtils: globalUtils
};