import CodeGen from '@alilc/lowcode-code-generator';
import file_readme from './files/README.md';
import file_viteConfig from './files/vite.config.js.js';
import file_gitignore from './files/gitignore';
import file_prettierrc from './files/prettierrc.json';
import file_eslintrc from './files/eslintrc.cjs';
var _CodeGen$utils = CodeGen.utils,
  createResultDir = _CodeGen$utils.resultHelper.createResultDir,
  runFileGenerator = _CodeGen$utils.templateHelper.runFileGenerator;
export function generateStaticFiles(root) {
  if (root === void 0) {
    root = createResultDir('.');
  }
  //创建README.md文件
  runFileGenerator(root, file_readme);
  //创建vite配置文件
  runFileGenerator(root, file_viteConfig);
  //创建gitignore配置文件
  runFileGenerator(root, file_gitignore);
  //创建prettier配置文件
  runFileGenerator(root, file_prettierrc);
  //创建eslint配置文件
  runFileGenerator(root, file_eslintrc);
  return root;
}