"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = createVueProjectBuilder;
exports.publishers = exports.plugins = void 0;
var _lowcodeCodeGenerator = _interopRequireDefault(require("@alilc/lowcode-code-generator"));
var _vue = _interopRequireDefault(require("./plugins/project/vue3"));
var _vue2 = _interopRequireDefault(require("./plugins/component/vue3/vue"));
var _methods = _interopRequireDefault(require("./plugins/component/vue3/methods"));
var _lifeCycles = _interopRequireDefault(require("./plugins/component/vue3/lifeCycles"));
var _styles = _interopRequireDefault(require("./plugins/component/vue3/styles"));
var _initState = _interopRequireDefault(require("./plugins/component/vue3/initState"));
var constants = _interopRequireWildcard(require("./plugins/component/vue3/const"));
var globalUtils = _interopRequireWildcard(require("./utils"));
var _postprocessor = require("./postprocessor");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createVueProjectBuilder() {
  return _lowcodeCodeGenerator["default"].createProjectBuilder({
    template: _vue["default"].template,
    plugins: {
      components: [
        // CodeGen.plugins.icejs.reactCommonDeps(),
        // CodeGen.plugins.common.esModule({ fileType: 'jsx' }),
        // CodeGen.plugins.common.styleImport(),
        // CodeGen.plugins.icejs.containerClass(),
        // CodeGen.plugins.icejs.containerInjectContext(),
        // CodeGen.plugins.icejs.containerInjectUtils(),
        // CodeGen.plugins.icejs.containerInjectDataSourceEngine(),
        // CodeGen.plugins.icejs.containerInjectI18n(),
        // CodeGen.plugins.icejs.containerInjectConstants(),
        // CodeGen.plugins.icejs.containerInitState(),
        // CodeGen.plugins.icejs.containerLifeCycle(),
        // CodeGen.plugins.icejs.containerMethod(),
        // examplePlugin(),
        // CodeGen.plugins.icejs.jsx({
        //   nodeTypeMapping: {
        //     Div: 'div',
        //     Component: 'div',
        //     Page: 'div',
        //     Block: 'div',
        //   },
        // }),
        // CodeGen.plugins.style.css(),
      ],
      pages: [
      // CodeGen.plugins.icejs.reactCommonDeps(),
      // CodeGen.plugins.common.esModule({ fileType: 'jsx' })
      // CodeGen.plugins.common.styleImport(),
      // CodeGen.plugins.icejs.containerClass(),
      // CodeGen.plugins.icejs.containerInjectContext(),
      // CodeGen.plugins.icejs.containerInjectUtils(),
      // CodeGen.plugins.icejs.containerInjectDataSourceEngine(),
      // CodeGen.plugins.icejs.containerInjectI18n(),
      // CodeGen.plugins.icejs.containerInjectConstants(),
      // CodeGen.plugins.icejs.containerInitState(),
      // CodeGen.plugins.icejs.containerLifeCycle(),
      // CodeGen.plugins.icejs.containerMethod(),
      // examplePlugin(),
      (0, _initState["default"])(), (0, _lifeCycles["default"])(), (0, _methods["default"])(), (0, _styles["default"])(), (0, _vue2["default"])({
        nodeTypeMapping: {
          Div: 'div',
          Component: 'div',
          Page: 'div',
          Block: 'div'
        }
      })
      // CodeGen.plugins.style.css(),
      ],

      router: [
      // CodeGen.plugins.common.esModule(),
      _vue["default"].plugins.router()],
      entry: [_vue["default"].plugins.entry()],
      app: [_vue["default"].plugins.app()],
      mainCss: [_vue["default"].plugins.mainCss()],
      // constants: [CodeGen.plugins.project.constants()],
      // utils: [
      //   CodeGen.plugins.common.esModule(),
      //   CodeGen.plugins.project.utils('react'),
      // ],
      // i18n: [CodeGen.plugins.project.i18n()],
      // globalStyle: [CodeGen.solutionParts.icejs.plugins.globalStyle()],
      htmlEntry: [_vue["default"].plugins.entryHtml()],
      packageJSON: [_vue["default"].plugins.packageJSON()]
    },
    postProcessors: [(0, _postprocessor.prettier)()]
  });
}
var publishers = _lowcodeCodeGenerator["default"].publishers;
exports.publishers = publishers;
var plugins = {
  methods: _methods["default"],
  vue: _vue2["default"],
  styles: _styles["default"],
  constants: constants,
  globalUtils: globalUtils
};
exports.plugins = plugins;