"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.transformThis2Context = transformThis2Context;
var _generator = _interopRequireDefault(require("@babel/generator"));
var _lowcodeCodeGenerator = _interopRequireDefault(require("@alilc/lowcode-code-generator"));
var parseExpressionConvertThis2Context = _lowcodeCodeGenerator["default"].utils.expressionParser.parseExpressionConvertThis2Context;
/**
 * 将所有的 this.xxx 替换为 __$$context.xxx
 * @param expr
 */
function transformThis2Context(expr, scope, _temp) {
  var _scope$bindings;
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$ignoreRootScope = _ref.ignoreRootScope,
    ignoreRootScope = _ref$ignoreRootScope === void 0 ? false : _ref$ignoreRootScope;
  if (ignoreRootScope && scope.parent == null) {
    return typeof expr === 'string' ? expr : (0, _generator["default"])(expr).code;
  }

  // 下面这种字符串替换的方式虽然简单直接，但是对于复杂场景会误匹配，故后期改成了解析 AST 然后修改 AST 最后再重新生成代码的方式
  // return expr
  //   .replace(/\bthis\.item\./g, () => 'item.')
  //   .replace(/\bthis\.index\./g, () => 'index.')
  //   .replace(/\bthis\./g, () => '__$$context.');
  return parseExpressionConvertThis2Context(expr, '__$$context', ((_scope$bindings = scope.bindings) === null || _scope$bindings === void 0 ? void 0 : _scope$bindings.getAllBindings()) || []);
}