"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _prettier = _interopRequireDefault(require("prettier"));
var _parserBabel = _interopRequireDefault(require("prettier/parser-babel"));
var _parserPostcss = _interopRequireDefault(require("prettier/parser-postcss"));
var _prettierPluginVue = _interopRequireDefault(require("prettier-plugin-vue"));
var _parserHtml = _interopRequireDefault(require("prettier/parser-html"));
var PARSERS = ['css', 'scss', 'less', 'json', 'html', 'vue'];
var factory = function factory(config) {
  var cfg = (0, _extends2["default"])({
    customFileTypeParser: {}
  }, config);
  var codePrettier = function codePrettier(content, fileType) {
    var parser;
    if (fileType === 'js' || fileType === 'jsx' || fileType === 'ts' || fileType === 'tsx') {
      parser = 'babel-ts';
    } else if (fileType === 'vue') {
      parser = 'vue';
    } else if (fileType === 'json') {
      parser = 'json-stringify';
    } else if (PARSERS.indexOf(fileType) >= 0) {
      parser = fileType;
    } else if (cfg.customFileTypeParser[fileType]) {
      parser = cfg.customFileTypeParser[fileType];
    } else {
      return content;
    }
    return _prettier["default"].format(content, {
      parser: parser,
      plugins: [_parserBabel["default"], _parserPostcss["default"], _prettierPluginVue["default"], _parserHtml["default"]].concat(cfg.plugins || []),
      singleQuote: true,
      jsxSingleQuote: false,
      htmlWhitespaceSensitivity: 'ignore',
      jsxBracketSameLine: false,
      vueIndentScriptAndStyle: false
    });
  };
  return codePrettier;
};
var _default = factory;
exports["default"] = _default;