"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _standalone = _interopRequireDefault(require("./standalone"));
/* eslint-disable no-console */

// import CodeGen from '@alilc/lowcode-code-generator';

self.onmessage = function (event) {
  var msg = event.data || {};
  if (msg.type === 'run') {
    run(msg);
  }
};
self.postMessage({
  type: 'ready'
});
function run(_x) {
  return _run.apply(this, arguments);
}
function _run() {
  _run = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(msg) {
    var solution, createAppBuilder, appBuilder, result, finalResult;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          print('begin run...');
          self.postMessage({
            type: 'run:begin'
          });
          solution = msg.solution;
          if (solution) {
            _context.next = 6;
            break;
          }
          throw new Error('solution is required');
        case 6:
          createAppBuilder = _standalone["default"].solutions[solution];
          if (!(typeof createAppBuilder !== 'function')) {
            _context.next = 9;
            break;
          }
          throw new Error("solution '" + solution + "' is invalid");
        case 9:
          appBuilder = createAppBuilder();
          print('generating from schema: %o', msg.schema);
          _context.next = 13;
          return appBuilder.generateProject(msg.schema);
        case 13:
          result = _context.sent;
          print('generated result: %o', result);
          finalResult = msg.flattenResult ? _standalone["default"].utils.resultHelper.flattenResult(result) : result;
          if (msg.flattenResult) {
            print('flatten result: %o', finalResult);
          }
          self.postMessage({
            type: 'run:end',
            result: finalResult
          });
          _context.next = 24;
          break;
        case 20:
          _context.prev = 20;
          _context.t0 = _context["catch"](0);
          printErr("" + _context.t0);
          self.postMessage({
            type: 'run:error',
            errorMsg: "" + ((_context.t0 === null || _context.t0 === void 0 ? void 0 : _context.t0.message) || _context.t0),
            errorDetail: "" + _context.t0
          });
        case 24:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[0, 20]]);
  }));
  return _run.apply(this, arguments);
}
function print(text) {
  var _console;
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  (_console = console).debug.apply(_console, ["[code-generator/worker]: " + text].concat(args));
  self.postMessage({
    type: 'stdout',
    data: text,
    args: args
  });
}
function printErr(text) {
  var _console2;
  for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }
  (_console2 = console).debug.apply(_console2, ["[code-generator/worker]: %c" + text, 'color:red'].concat(args));
  self.postMessage({
    type: 'stderr',
    data: text,
    args: args
  });
}