"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _lowcodeCodeGenerator = _interopRequireDefault(require("@alilc/lowcode-code-generator"));
var _generator = _interopRequireWildcard(require("../generator"));
var _const = require("../generator/plugins/component/vue3/const");
var globalUtils = _interopRequireWildcard(require("../generator/utils"));
var _vue = _interopRequireDefault(require("../generator/plugins/project/vue3"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * 低代码引擎的出码模块，负责将编排产出的 Schema 转换成实际可执行的代码。
 * 注意：为了保持 API 的稳定性, 这里所有导出的 API 均要显式命名方式导出
 *     （即用 export { xxx } from 'xx' 的方式，不要直接 export * from 'xxx')
 *      而且所有导出的 API 务必在 tests/public 中编写单元测试
 */
// import './polyfills/buffer';
// 引入全局常用工具
var _default = {
  createProjectBuilder: _lowcodeCodeGenerator["default"].createProjectBuilder,
  createModuleBuilder: _lowcodeCodeGenerator["default"].createModuleBuilder,
  solutions: {
    vue3: _generator["default"]
  },
  solutionParts: {
    vue3: _vue["default"]
  },
  publishers: {
    zip: _lowcodeCodeGenerator["default"].publishers.zip
  },
  plugins: {
    common: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].plugins.common),
    style: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].plugins.style),
    project: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].plugins.project),
    vue3: (0, _extends2["default"])({}, _generator.plugins)
  },
  postprocessor: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].postprocessor),
  utils: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].utils, globalUtils),
  chunkNames: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].chunkNames, {
    VUE_CHUNK_NAME: _const.VUE_CHUNK_NAME
  }),
  defaultLinkAfter: (0, _extends2["default"])({}, _lowcodeCodeGenerator["default"].defaultLinkAfter),
  constants: _lowcodeCodeGenerator["default"].constants
}; // // 一些类型定义
// export * from './types';
// // 一些常量定义
// export * from './const';
// // 一些工具函数
// export * from './analyzer/componentAnalyzer';
// export * from './parser/SchemaParser';
// export * from './generator/ChunkBuilder';
// export * from './generator/CodeBuilder';
// export * from './generator/ModuleBuilder';
// export * from './generator/ProjectBuilder';
exports["default"] = _default;